# optimal tour value is 1740.7815
# this is a possible solution for HW 

set V := { read "germany18.dat" as "<1s>" comment "#" };
set E := { <i,j> in V * V with i < j };

# Here is how you could add all necessary subtour inequalities:
#set P[] := subsets(V, 3, floor(card(V)/2) );
#set K := indexset(P);

# here are enough to solve the instance:
set K := { 1, 2, 3, 4, 5, 6, 7 };
set P[K] := <1> {"Kiel",  "Hannover", "Schwerin", "Hamburg", "Bremen"},
    	    <2> {"Berlin", "Potsdam", "Dresden", "Magdeburg", "Erfut", "Dresden"},
   	    <3> {"Dusseldorf", "Koln", "Essen"},
	    <4> {"Mainz", "Wiesbaden", "Saarbrucken", "Stuttgart", "Munchen"},
	    <5> {"Kiel", "Schwerin", "Hamburg"},
  	    <6> {"Berlin", "Potsdam", "Dresden"},
	    <7> {"Kiel", "Schwerin", "Hamburg","Berlin", "Potsdam", "Dresden"};


param px[V] := read "germany18.dat" as "<1s> 2n" comment "#";
param py[V] := read "germany18.dat" as "<1s> 3n" comment "#";

defnumb dist(a,b) := sqrt((px[a]-px[b])^2 + (py[a]-py[b])^2);

var x[E] binary;

minimize cost: sum <i,j> in E : dist(i,j) * x[i, j];

subto two_connected:
      forall <v> in V do
      	     (sum <v,j> in E : x[v,j])
	     + (sum <i,v> in E : x[i,v]) == 2;
subto no_subtour:
      forall <k> in K do
	     sum <i,j> in E with <i> in P[k] and <j> in P[k] : x[i,j]
	     <= card(P[k]) - 1;
