#
#    TSP formulation using a single commodity flow formulation
#

# definition of the data file to be read
param datafile := "berlin52.dat";
# number of cities to read from data file
param cities := 52;

set V   := { read datafile as "<1s>" comment "#" use cities };
set E   := { <i,j> in V * V with i != j };

param px[V] := read datafile as "<1s> 2n" comment "#" use cities;
param py[V] := read datafile as "<1s> 3n" comment "#" use cities;

defnumb dist_euc(a,b) := sqrt((px[a] - px[b])^2 + (py[a] - py[b])^2);

var x[E] binary;
var y[E] real >= 0;

minimize cost: sum <i,j> in E : dist_euc(i,j) * x[i, j];

# Degree Inequalities
subto one_in:
   forall <j> in V do sum <i,j> in E : x[i,j] == 1;
subto one_out:
   forall <i> in V do sum <i,j> in E : x[i,j] == 1;

# Network flow constraints
   # add them!
